import os

def splitfile(infilepath, chunksize):
    fname, ext = infilepath.rsplit('.',1)
    i = 0
    written = False
    with open(infilepath, 'rb') as infile:
        while True:
            if i > 9:
                outfilepath = "{}{}.{}".format(fname, i, ext)
            else:
                outfilepath = "{}0{}.{}".format(fname, i, ext)
            with open(outfilepath, 'wb') as outfile:
                for line in (infile.readline() for _ in range(chunksize)):
                    outfile.write(line)
                written = bool(line)
            if not written:
                break
            i += 1
    os.remove(infilepath)


def mergefile(indir, filename):
    dir_files = os.listdir(indir)
    the_file = indir + filename
    with open(the_file, 'ab') as infile:
        for chunk in dir_files:
            print(chunk)
            file_locate = "C:/chunk/split/" + chunk
            fileTemp = open(file_locate, "rb")
            infile.write(fileTemp.read())
            fileTemp.close()
            os.remove(file_locate)

    infile.close()


def chunked(file, chunks):
    i = 0
    with open(file, "rb") as in_file:
        bytes = in_file.read(chunks) # read 5000 bytes
        while bytes:

            if i < 10:
                with open("C:/chunk/split/out-file-0000" + str(i), 'wb') as output:
                    output.write(bytes)
            elif 10 <= i < 100:
                with open("C:/chunk/split/out-file-000" + str(i), 'wb') as output:
                    output.write(bytes)
            elif 100 <= i < 1000:
                with open("C:/chunk/split/out-file-00" + str(i), 'wb') as output:
                    output.write(bytes)
            elif 1000 <= i < 10000:
                with open("C:/chunk/split/out-file-0" + str(i), 'wb') as output:
                    output.write(bytes)
            elif 10000 <= i < 100000:
                with open("C:/chunk/split/out-file-" + str(i), 'wb') as output:
                    output.write(bytes)       

            # with open("C:/chunk/split/out-file-" + str(i), 'wb') as output:
            #     output.write(bytes)
            bytes = in_file.read(chunks) # read another 5000 bytes
            i += 1


chunked("C:/chunk/file/acro.exe", 131072)  # Testing 128KB chunks


# num_lines = sum(1 for _ in open("D:/chunks/df14.iso", 'rb'))
# line_break = num_lines // 100 + 1
# print(num_lines, line_break)

# input()

# splitfile("D:/chunks/df14.iso", line_break)

input()

mergefile("C:/chunk/split/", "acro_rebuilt.exe")  # Rejoin the chunks in the given folder
